<?php
// $Id: system.inc,v 1.1.2.2 2009/03/11 12:14:11 gordon Exp $

/**
 * @file
 * Provide system intergration for charges to allow low level actions to be
 * done one changes
 */

/**
 * Implementation of hook_ec_charge_filter_info().
 */
function system_ec_charge_filter_info() {
  return array(
    'cookie' => array(
      'name' => t('Cookie*'),
      'description' => t('Validate that a cookie exists and it is equal to a defined value'),
      'module' => 'system_cookie',
      'file' => 'system.inc',
      'core' => TRUE,
    ),
    'session' => array(
      'name' => t('Session*'),
      'description' => t('Validate that a session variable exists and it is equal to a defined value'),
      'module' => 'system_session',
      'file' => 'system.inc',
      'core' => TRUE,
    ),
  );
}

/**
 * Implementation of hook_ec_charge_calculation_info().
 */
function system_ec_charge_calculation_info() {
  return array(
    'calc' => array(
      'name' => t('Calculation'),
      'description' => t('Provide a method to allow the calculation of the charge.'),
      'module' => 'system_calc',
      'file' => 'system.inc',
      'core' => TRUE,
    ),
  );
}

function system_calc_calculation_form(&$form_state, $settings) {
  $form = array();
  $default = array('calc' => '');
  $settings+= $default;

  $form['calc'] = array(
    '#type' => 'textfield',
    '#title' => t('Calculation'),
    '#default_value' => $settings['calc'],
  );

  return $form;
}

function system_calc_calculation_settings() {
  return array('calc');
}

function system_calc_calculation_process($settings, $variables, $txn) {
  $keys = array_map('_system_calc_map_variables', array_keys($variables));
  $vars = array_combine($keys, $variables);

  $calc = strtr($settings['calc'], $vars);

  $price = eval('return '. $calc .';');

  $misc = array(
    'description' => $settings['name'],
    'price' => $price,
  );

  return $misc;
}

function _system_calc_map_variables($a) {
  return '['. $a .']';
}

