<?php
// $Id: theme.inc,v 1.1.2.3 2009/03/06 05:17:29 gordon Exp $
/**
 * @file
 */

/**
 * Implementation of hook_preprocess_hook().
 */
function ec_store_preprocess_invoice(&$varibles) {
  drupal_add_css(drupal_get_path('module', 'ec_store') .'/templates/invoice.css');

  $txn =& $varibles['transaction'];
  
  $varibles['template_files'][] = 'invoice-'. $txn->type;
  $varibles['template_files'][] = 'invoice-'. $txn->payment_method;
  $varibles['template_files'][] = 'invoice-'. $txn->type .'-'. $txn->payment_method;

  $varibles['billing_address'] = theme('formatted_address', $txn->address['billing']);
  if (isset($txn->shippable) && $txn->shippable) {
    $varibles['shipping_address'] = theme('formatted_address', $txn->address['shipping']);
  }
  
  $subtotal = 0;
  foreach ($txn->items as $nid => $item) {
    $txn->items[$nid]->price = ec_store_adjust_misc($txn, $item);
    $txn->items[$nid]->formatted_price = format_currency($txn->items[$nid]->price);
    $txn->items[$nid]->quantity_visible = ec_product_has_quantity($item);
    $subtotal+= $txn->items[$nid]->price;
  }

  $varibles['subtotal'] = format_currency($subtotal);

  $varibles['gross'] = format_currency(ec_store_transaction_calc_gross($txn));

  $varibles+= (array)$varibles['transaction'];

  // TODO: Need to fill in more information in the misc variables
  foreach ($varibles['misc'] as $id => $misc) {
    if ($misc->seen) {
      unset($varibles['misc'][$id]);
    }
  }
}
